Package oracle.dbtools.plugin.api.servlet

## Interface HasDynamicAuthorization

- All Known Implementing Classes:
    `HttpServletBase`

      public interface HasDynamicAuthorization

  Optional interface implemented by `HttpServlet`s which need to dynamically determine what `AuthorizationConstraint` is required for a request.
  Author:
    cdivilly

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static AuthorizationConstraint` | `USE_DEFAULT_CONSTRAINTS` | Constant denoting that the runtime's default logic for discovering what `AuthorizationConstraint` to apply to a request should be used.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AuthorizationConstraint` | `getConstraint​(javax.servlet.http.HttpServletRequest request)` | Determine the `AuthorizationConstraint` that applies to a resource.

- - ### Field Detail

    - #### USE_DEFAULT_CONSTRAINTS

          static final AuthorizationConstraint USE_DEFAULT_CONSTRAINTS

      Constant denoting that the runtime's default logic for discovering what `AuthorizationConstraint` to apply to a request should be used.

  - ### Method Detail

    - #### getConstraint

          AuthorizationConstraint getConstraint​(javax.servlet.http.HttpServletRequest request)
                                         throws javax.servlet.ServletException,
                                                java.io.IOException

      Determine the `AuthorizationConstraint` that applies to a resource.
      Parameters:
        `request` - an `HttpServletRequest` object that contains the request the client has made of the servlet
      Returns:
        `AuthorizationConstraint` instance if a constraint applies to the request. `null` if no constraint applies to the request. `USE_DEFAULT_CONSTRAINTS` if this method cannot determine what constraint applies to the request, and therefore the runtime's default `AuthorizationConstraint` discovery logic will be applied to the request.
      Throws:
        `java.io.IOException` - if an input or output error is detected when the servlet determines the `AuthorizationConstraint`
        `javax.servlet.ServletException` - if the request for the dynamic privilege could not be handled